unit perceptron;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, TeeProcs, TeEngine, Chart, Series;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    Edit1: TEdit;
    BitBtnTreinar: TBitBtn;
    Bevel2: TBevel;
    Label3: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    Edit3: TEdit;
    Chart1: TChart;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    Shape8: TShape;
    Shape9: TShape;
    Label5: TLabel;
    Panel1: TPanel;
    LabelResultado: TLabel;
    Label6: TLabel;
    Bevel3: TBevel;
    Series1: TAreaSeries;
    Shape10: TShape;
    Shape11: TShape;
    Shape12: TShape;
    Shape13: TShape;
    procedure Inicializa();
    procedure Teste();
    procedure FormCreate(Sender: TObject);
    procedure BitBtnTreinarClick(Sender: TObject);
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape4MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape5MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape6MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape7MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape8MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape9MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    w : array [1..10] of double;
    t : array [1..9] of integer;
    h : array [1..9] of integer;

    entrada : array [1..9] of double;

    n : double;

    u : double;

    erroT : double;
    erroH : double;
    erro  : double;

    e : double;

    ciclos : double;
    c : double;

    y : double;

  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Inicializa();
var i : integer;
begin
    erroT := 0;
    erroH := 0;
    erro := 0;
    e := 0;

    ciclos := 0;
    c := 0;

    y := 0;

    n := strtofloat(edit1.text);
    e := strtofloat(edit2.text);
    c := strtofloat(edit3.text);

    u := 0;

    for i:=1 to 9 do
    begin
        w[i] := 0;
        entrada[i] := 0;
    end;

    w[10] := 0;

    t[1]:= 1; t[2]:= 1; t[3]:= 1;
    t[4]:= 0; t[5]:= 1; t[6]:= 0;
    t[7]:= 0; t[8]:= 1; t[9]:= 0;

    h[1]:= 1; h[2]:= 0; h[3]:= 1;
    h[4]:= 1; h[5]:= 1; h[6]:= 1;
    h[7]:= 1; h[8]:= 0; h[9]:= 1;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    Inicializa();
end;

procedure TForm1.BitBtnTreinarClick(Sender: TObject);
var i : integer;
begin

    Inicializa();

    Series1.Clear;

    repeat // Repeat para T e H

        //////////////////////////////////
        //                              //
        //  Treinamento da rede para T  //
        //                              //
        //////////////////////////////////

        u := 0;

        for i:=1 to 9 do
        begin
            u := u + (w[i] * t[i]);

        end; // fim do for

        u := u - w[10];


        ////////////////////////////////////
        //                                //
        // Verificao do valor de sada  //
        //                                //
        ////////////////////////////////////

        u := -u;

        y:= 1/(1+ exp(u));

        erroT := ((y * (1 - y)) * (1 - y));

        ////////////////////////////
        //                        //
        // Atualizao dos pesos  //
        //                        //
        ////////////////////////////

        for i:=1 to 9 do
        begin
            w[i] := w[i] + (n * erroT * t[i]);

        end; //fim do for

        w[10] := w[10] + (n * erroT * (-1));

        //////////////////////////////////
        //                              //
        //  Treinamento da rede para H  //
        //                              //
        //////////////////////////////////

        u := 0;

        for i:=1 to 9 do
        begin
            u := u + (w[i] * h[i]);
        end; // fim do for

        u := u - w[10];


        ////////////////////////////////////
        //                                //
        // Verificao do valor de sada  //
        //                                //
        ////////////////////////////////////

        u := -u;

        y:= 1/(1+ exp(u));

        erroH := ((y * (1 - y)) * (0 - y));

        ////////////////////////////
        //                        //
        // Atualizao dos pesos  //
        //                        //
        ////////////////////////////

        for i:=1 to 9 do
        begin
            w[i] := w[i] + (n * erroH * h[i]);

        end; //fim do for

        w[10] := w[10] + (n * erroH * (-1));

        erro := sqr(erroT) + sqr(erroH);  // soma quadrtica

        ciclos := ciclos + 1; // Atualiza a varivel ciclos

        series1.AddXY(ciclos,erro,'',clNavy);

    until (((erroT < e) and (erroH < e)) or (ciclos = c)); //fim do repeat

end; // fim do BitBtnTreinarClick

procedure TForm1.Teste();
var i : integer;
begin

    //////////////////////////////
    //                          //
    //  Testa dados de entrada  //
    //                          //
    //////////////////////////////

    u := 0;

    for i:=1 to 9 do
    begin
        u := u + (w[i] * entrada[i]);
    end; // fim do for

    u := u - w[10];

    y:= 1/(1+ exp(-u));

    if (y > 0.7) then
    begin
        labelResultado.caption := ' um T';
        label6.caption := 'y = ' + floattostr(y);
    end
    else
    begin
        if (y < 0.3) then
        begin
            labelResultado.caption := ' um H';
            label6.caption := 'y = ' + floattostr(y);
        end
        else
        begin
            labelResultado.caption := 'Valor no determinado!!!';
        end;
    end;

end;

   ////////////////////////////////////////////////////////////////
   //                                                            //
   //         Procedimentos referentes as cores do Grid          //
   //                                                            //
   ////////////////////////////////////////////////////////////////


procedure TForm1.Shape1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if (Shape1.Brush.Color = clYellow) then
    begin
        Shape1.Brush.Color := clBlack;
        entrada[1] := 1;
        teste();
    end
    else
    begin
        Shape1.Brush.Color := clYellow;
        entrada[1] := 0;
        teste();
    end;
end;

procedure TForm1.Shape2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if (Shape2.Brush.Color = clYellow) then
    begin
        Shape2.Brush.Color := clBlack;
        entrada[2] := 1;
        teste();
    end
    else
    begin
        Shape2.Brush.Color := clYellow;
        entrada[2] := 0;
        teste();
    end;
end;

procedure TForm1.Shape3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if (Shape3.Brush.Color = clYellow) then
    begin
        Shape3.Brush.Color := clBlack;
        entrada[3] := 1;
        teste();
    end
    else
    begin
        Shape3.Brush.Color := clYellow;
        entrada[3] := 0;
        teste();
    end;
end;

procedure TForm1.Shape4MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if (Shape4.Brush.Color = clYellow) then
    begin
        Shape4.Brush.Color := clBlack;
        entrada[4] := 1;
        teste();
    end
    else
    begin
        Shape4.Brush.Color := clYellow;
        entrada[4] := 0;
        teste();
    end;
end;

procedure TForm1.Shape5MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if (Shape5.Brush.Color = clYellow) then
    begin
        Shape5.Brush.Color := clBlack;
        entrada[5] := 1;
        teste();
    end
    else
    begin
        Shape5.Brush.Color := clYellow;
        entrada[5] := 0;
        teste();
    end;
end;

procedure TForm1.Shape6MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if (Shape6.Brush.Color = clYellow) then
    begin
        Shape6.Brush.Color := clBlack;
        entrada[6] := 1;
        teste();
    end
    else
    begin
        Shape6.Brush.Color := clYellow;
        entrada[6] := 0;
        teste();
    end;
end;

procedure TForm1.Shape7MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if (Shape7.Brush.Color = clYellow) then
    begin
        Shape7.Brush.Color := clBlack;
        entrada[7] := 1;
        teste();
    end
    else
    begin
        Shape7.Brush.Color := clYellow;
        entrada[7] := 0;
        teste();
    end;
end;

procedure TForm1.Shape8MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if (Shape8.Brush.Color = clYellow) then
    begin
        Shape8.Brush.Color := clBlack;
        entrada[8] := 1;
        teste();
    end
    else
    begin
        Shape8.Brush.Color := clYellow;
        entrada[8] := 0;
        teste();
    end;
end;

procedure TForm1.Shape9MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if (Shape9.Brush.Color = clYellow) then
    begin
        Shape9.Brush.Color := clBlack;
        entrada[9] := 1;
        teste();
    end
    else
    begin
        Shape9.Brush.Color := clYellow;
        entrada[9] := 0;
        teste();
    end;
end;

   ////////////////////////////////////////////////////////////////
   //                                                            //
   // --> Fim dos procedimentos referentes as cores do Grid <--  //
   //                                                            //
   ////////////////////////////////////////////////////////////////

end.
